aboutsummaryrefslogtreecommitdiff
path: root/sys/tools
diff options
context:
space:
mode:
authorKonstantin Belousov <kib@FreeBSD.org>2021-11-05 08:07:24 +0000
committerKonstantin Belousov <kib@FreeBSD.org>2021-12-06 18:46:49 +0000
commitab4524b3d7fba872a143b03c9346cb04c3670efa (patch)
tree6c390480ef7923056279e38b29521bb968239d20 /sys/tools
parent9b135747a326080f0ffc96ddc3e0d7a4fbc1dfe1 (diff)
downloadsrc-ab4524b3d7fba872a143b03c9346cb04c3670efa.tar.gz
src-ab4524b3d7fba872a143b03c9346cb04c3670efa.zip
amd64: wrap 64bit sigtramp into vdso
Reviewed by: emaste Discussed with: jrtc27 Tested by: pho Sponsored by: The FreeBSD Foundation MFC after: 1 month Differential revision: https://reviews.freebsd.org/D32960
Diffstat (limited to 'sys/tools')
-rw-r--r--sys/tools/amd64_vdso.sh59
-rw-r--r--sys/tools/vdso_wrap.S48
2 files changed, 107 insertions, 0 deletions
diff --git a/sys/tools/amd64_vdso.sh b/sys/tools/amd64_vdso.sh
new file mode 100644
index 000000000000..39406eccd2ef
--- /dev/null
+++ b/sys/tools/amd64_vdso.sh
@@ -0,0 +1,59 @@
+#!/bin/sh
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 The FreeBSD Foundation
+# All rights reserved.
+#
+# This software was developed by Konstantin Belousov <kib@FreeBSD.org>
+# under sponsorship from the FreeBSD Foundation.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+set -e
+
+${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c \
+ -o sigtramp.pico -I. -I"${S}" -include opt_global.h \
+ "${S}"/amd64/amd64/sigtramp.S
+
+# We need to make vdso as compact as possible, for it to leave space
+# for other things in the shared page. For this, we pack everything
+# into single loadable segment.
+#
+# -z rodynamic is undocumented lld-specific option, seemingly required
+# for lld to avoid putting dynamic into dedicated writeable segment,
+# despite ldscript placement. It is ignored by ld.bfd but ldscript
+# alone is enough there.
+#
+${LD} --shared -Bsymbolic -soname="elf-vdso.so.1" \
+ -T "${S}"/conf/vdso_amd64.ldscript \
+ --eh-frame-hdr --no-undefined -z rodynamic -z norelro -nmagic \
+ --hash-style=sysv --fatal-warnings --strip-all \
+ -o elf-vdso.so.1 sigtramp.pico
+
+${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c \
+ -o elf-vdso.so.o -I. -I"${S}" -include opt_global.h \
+ -DVDSO_NAME=elf_vdso_so_1 -DVDSO_FILE=elf-vdso.so.1 \
+ "${S}"/tools/vdso_wrap.S
+
+${NM} -D elf-vdso.so.1 | \
+ awk '/__vdso_sigcode/{printf "#define VDSO_SIGCODE_OFFSET 0x%s\n",$1}' \
+ >vdso_offsets.h
diff --git a/sys/tools/vdso_wrap.S b/sys/tools/vdso_wrap.S
new file mode 100644
index 000000000000..807dcf9c06f4
--- /dev/null
+++ b/sys/tools/vdso_wrap.S
@@ -0,0 +1,48 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2021 The FreeBSD Foundation
+ *
+ * This software was developed by Konstantin Belousov <kib@FreeBSD.org>
+ * under sponsorship from the FreeBSD Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+
+#define VDSO_BLOB_START(S) __CONCAT(_binary_, __CONCAT(S, _start))
+#define VDSO_BLOB_END(S) __CONCAT(_binary_, __CONCAT(S, _end))
+#define VDSO_BLOB_SIZE(S) __CONCAT(_binary_, __CONCAT(S, _size))
+
+ .section .rodata, "a", %progbits
+ .globl VDSO_BLOB_START(VDSO_NAME)
+ .type VDSO_BLOB_START(VDSO_NAME), %object
+ .size VDSO_BLOB_START(VDSO_NAME), 0
+VDSO_BLOB_START(VDSO_NAME):
+ .incbin __XSTRING(VDSO_FILE)
+ .globl VDSO_BLOB_END(VDSO_NAME)
+ .type VDSO_BLOB_END(VDSO_NAME), %object
+ .size VDSO_BLOB_END(VDSO_NAME), 0
+VDSO_BLOB_END(VDSO_NAME):
+ .globl VDSO_BLOB_SIZE(VDSO_NAME)
+ .set VDSO_BLOB_SIZE(VDSO_NAME), . - VDSO_BLOB_START(VDSO_NAME)